#!/usr/local/bin/php
<?php
/******************************************************************************
 * File:				cron4rss.php
 * Description:			PHP page for generating the RSS feeds with a cronjob
 * Author:				Thorsten Rinne		thorsten@rinne.info
 * Date:				2003-08-04
 * Last change:			2003-09-04
 * Copyright:           (c) 2001-2003 Thorsten Rinne und Bastian Pttner
 * 
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * Add to your cron.d:
 -------------------------------------------------------------------------------
 0 * * * * /usr/local/bin/php -f /path/to/your/faq//xml/cron4rss.php
 -------------------------------------------------------------------------------
 ******************************************************************************/

require ("../inc/data.php");
require ("../inc/config.php");
require ("../inc/database.php");
require ("../inc/functions.php");

$metaCharset = "iso-8859-1";

$db = new db_mysql();
$db->connect($mysql_server, $mysql_user, $mysql_passwort, $mysql_db);
    
$result = $db->query("SELECT datum, header, artikel, link, linktitel, target FROM ".$sqltblpre."faqnews ORDER BY datum desc LIMIT 0,".$numNewsArticles);

$output = "<?xml version=\"1.0\" encoding=\"".$metaCharset."\" standalone=\"yes\" ?>\n<rss version=\"2.0\">\n<channel>\n";
$output .= "<title>".$title."</title>\n";
$output .= "<description>".$metaDescription."</description>\n";
$output .= "<link>http://".$_SERVER["HTTP_HOST"].str_replace("xml/cron4rss.php", "", $_SERVER["PHP_SELF"])."</link>";
if ($db->num_rows($result) > 0) {
    while ($row = $db->fetch_object($result)) {
        $output .= "\t<item>\n";
        $output .= "\t\t<title>".$row->header."</title>\n";
        $output .= "\t\t<description>".stripslashes($row->artikel)."</description>\n";
        $output .= "\t\t<link>http://".$_SERVER["HTTP_HOST"].str_replace("xml/cron4rss.php", "", $_SERVER["PHP_SELF"])."</link>\n";
        $output .= "\t</item>\n";
        }
    }
$output .= "</channel>\n</rss>";
$fp = @fopen("news.xml", "w");
fputs($fp, $output);
fclose($fp);
unset($result);

$result = $db->query("SELECT DISTINCT ".$sqltblpre."faqdata.id, ".$sqltblpre."faqdata.lang, ".$sqltblpre."faqdata.thema, ".$sqltblpre."faqdata.rubrik, ".$sqltblpre."faqvisits.visits FROM ".$sqltblpre."faqvisits, ".$sqltblpre."faqdata WHERE ".$sqltblpre."faqdata.id = ".$sqltblpre."faqvisits.id AND ".$sqltblpre."faqdata.lang = ".$sqltblpre."faqvisits.lang AND ".$sqltblpre."faqdata.active = 'yes' ORDER BY ".$sqltblpre."faqvisits.visits DESC LIMIT 0,10");

$output = "<?xml version=\"1.0\" encoding=\"".$metaCharset."\" standalone=\"yes\" ?>\n<rss version=\"2.0\">\n<channel>\n";
$output .= "<title>".$title."</title>\n";
$output .= "<description>".$metaDescription."</description>\n";
$output .= "<link>http://".$_SERVER["HTTP_HOST"]."</link>";
if ($db->num_rows($result) > 0) {
    $i = 1;
        while ($row = $db->fetch_object($result)) {
        $output .= "\t<item>\n";
        $output .= "\t\t<title>[".$i.".] ".$row->visits." ".$msgViews.":</title>\n";
        $output .= "\t\t<description>".stripslashes(makeShorterText($row->thema, 8))."</description>\n";
        $output .= "\t\t<link>http://".$_SERVER["HTTP_HOST"].str_replace("xml/cron4rss.php", "index.php", $_SERVER["PHP_SELF"])."?aktion=artikel&amp;rubrik=".$row->rubrik."&amp;id=".$row->id."&amp;lang=".$row->lang."</link>\n";
        $output .= "\t</item>\n";
        $i++;
        }
    }
$output .= "</channel>\n</rss>";
$fp = fopen("topten.xml", "w");
fputs($fp, $output);
fclose($fp);
unset($result);


$result = $db->query("SELECT DISTINCT ".$sqltblpre."faqdata.id, ".$sqltblpre."faqdata.lang, ".$sqltblpre."faqdata.rubrik, ".$sqltblpre."faqdata.thema, ".$sqltblpre."faqdata.datum, ".$sqltblpre."faqvisits.visits FROM ".$sqltblpre."faqdata, ".$sqltblpre."faqvisits WHERE ".$sqltblpre."faqdata.id = ".$sqltblpre."faqvisits.id AND ".$sqltblpre."faqdata.lang = ".$sqltblpre."faqvisits.lang AND ".$sqltblpre."faqdata.active = 'yes' ORDER BY ".$sqltblpre."faqdata.datum desc LIMIT 0,5");

$output = "<?xml version=\"1.0\" encoding=\"".$metaCharset."\" standalone=\"yes\" ?>\n<rss version=\"2.0\">\n<channel>\n";
$output .= "<title>".$title."</title>\n";
$output .= "<description>".$metaDescription."</description>\n";
$output .= "<link>http://".$_SERVER["HTTP_HOST"]."</link>";
if ($num = $db->num_rows($result) > 0) {
    while ($row = $db->fetch_object($result)) {
        $output .= "\t<item>\n";
        $output .= "\t\t<title>".makeDate($row->datum)."</title>\n";
        $output .= "\t\t<description>".stripslashes(makeShorterText($row->thema, 8))." (".$row->visits." ".$msgViews.")</description>\n";
        $output .= "\t\t<link>http://".$_SERVER["HTTP_HOST"].str_replace("xml/cron4rss.php", "index.php", $_SERVER["PHP_SELF"])."?aktion=artikel&amp;rubrik=".$row->rubrik."&amp;id=".$row->id."&amp;lang=".$row->lang."</link>\n";
        $output .= "\t</item>\n";
        }
    }
$output .= "</channel>\n</rss>";
$fp = fopen("latest.xml", "w");
fputs($fp, $output);
fclose($fp);
unset($result);
?>