<?php
/*
 * FAQ FRENZY
 * faq.php - All End-User Functions. You may want to rename this to 'index.php'
 * Version 1.0, 15-Jan-04
 * Copyright 2003,2004 Ross W. Poulton
 * ross@rossp.org
 * http://www.rossp.org/
 * 
 * This file is part of FAQ Frenzy.
 *
 * FAQ Frenzy is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * FAQ Frenzy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

$myEnv["module"] = "faqfrenzy";
$myEnv["output"] = "html";
                                                                                
require_once("../../config.inc.php");
require_once(INCLUDEPATH . "container.inc.php");
                                                                                
// adding file revision into global array
revisionInit("\$Revision: 1.3 $", __FILE__);
                                                                                
/* Include Common Functions */
require_once "inc/setup.inc.php";

/* Grab our main variables from either a POST or GET, 
   with priority given to POST. */

//activity
$a = isset($_POST['a']) ? $_POST['a'] : (isset($_GET['a'])?$_GET['a']:"cat");
// categoryid
$c = isset($_POST['c']) ? (int)$_POST['c'] : (isset($_GET['c'])?(int)$_GET['c']:0);
//faqid
$f = isset($_POST['f']) ? (int)$_POST['f'] : (isset($_GET['f'])?(int)$_GET['f']:0);
// search string
$search_string = isset($_POST['search_string']) ? $_POST['search_string'] : (isset($_GET['search_string'])?$_GET['search_string']:"");

if ($a == 'srch') {
	/* If the user wants to search, lets look for FAQ's
	   that match $q. Any matches link to the FAQ, with 
	   highlighting turned on. */

	$smarty->assign('search_string',$search_string);
	/* Add Slashes for database security */
	$q = $conn->QMagic("%".$search_string."%");

	/* Build our database query */
	$sql = "SELECT * FROM mgw_faqfrenzy_questions
		WHERE faqtitle LIKE $q
		OR faqdescription LIKE $q
		OR faqsolution LIKE $q
		OR faqkeywords LIKE $q";

	/* Execute the query */
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	
	$search_results=array();
	while ($row = $res->FetchRow()) {
	    $search_results[]=$row;
	}
		
	$smarty->assign('search_results',$search_results);
	$smarty->display('faqfrenzy_search_results.tpl');

} elseif ($a == 'cat') {
	/* Display category '$c' to the user, listing all FAQ's in this cat. */

	$c = $conn->QMagic($c);
	/* Firstly, list all this categories sub-categories */
	$sql = "SELECT * FROM mgw_faqfrenzy_categories WHERE catparent = $c";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	
        $categories=array();
        while ($row = $res->FetchRow()) {
	    $row["faqcount"]=$conn->GetOne("SELECT COUNT(*) FROM mgw_faqfrenzy_questions WHERE catid = '$row[catid]'");
            $categories[]=$row;
        }

	/* Display the FAQ's in this category */

	/* Query database */
	$sql = "SELECT * FROM mgw_faqfrenzy_questions WHERE catid = $c";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $faqs=array();
        while ($row = $res->FetchRow()) {
	    $faqs[]=$row;
	}
	
	$smarty->assign('categories',$categories);
	$smarty->assign('faqs',$faqs);
	$smarty->display('faqfrenzy_categories.tpl');

////////////////////////////////////////////////////////////////////////////////

} elseif ($a == 'faq') {
	/* Display an FAQ identified by $f */
	
	/* Execute database query */
	$sql = "SELECT * FROM mgw_faqfrenzy_questions WHERE faqid = $f";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	$row = $res->FetchRow();

	$smarty->assign('faqentry',$row);

	$sql = "SELECT * FROM mgw_faqfrenzy_relationships WHERE relfaqid1 = $f OR relfaqid2 = $f";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	$relatedfaqs=array();
	while ($row = $res->FetchRow()) {
	    if ($row["relfaqid1"] == $f) {
	        $sql2="SELECT * FROM mgw_faqfrenzy_questions WHERE faqid = ".$row["relfaqid2"];
	    } else {
	        $sql2="SELECT * FROM mgw_faqfrenzy_questions WHERE faqid = ".$row["relfaqid1"];
	    }
	    if (!$res2 = $conn->Execute($sql2)) exit(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
	    $row2 = $res2->FetchRow();
	    $relatedfaqs[]=$row2;
	}
	$smarty->assign('relatedfaqs',$relatedfaqs);
	// assign the search string for highlight purposes
	$smarty->assign('search_string',$search_string);

	if (queryRights2_bool('root_modules_faqfrenzy_admin')) {
	    $smarty->assign("show_edit_link",1);
	}
	$smarty->display('faqfrenzy_faqentry.tpl');
	
}

?>
