<?php

class forum extends CObject{

  /************************
   * Constructor
   * Save last login date into table
   * @param obj forumSettings
   * @param obj forumUser
   ***/
  function forum(&$forumSettings, &$forumUser) {
    global $conn;

    $this->regVar("action", 				NULL, 					true, false,"n_*");
    $this->regVar("newThreads",			NULL, 					false, true,"n_*");
    $this->regArray("langText");

    $this->forumSettings = $forumSettings;
    $this->forumUser = $forumUser;
    //$this->forumSettings->printAll();
    $sql = "SELECT * FROM ". $this->forumSettings->sql_userLog_table ." WHERE u_id='". (int)$this->forumUser->userId . "'";
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

    $numRows = $res->RecordCount();
    $now = $conn->DBTimeStamp(time());
    if ($numRows > 0) {
      $row = $res->FetchRow();
      $this->forumUser->last_login_date = "'".$row["last_login_date"]."'";
      $sql2 = "UPDATE ". $this->forumSettings->sql_userLog_table ." SET last_login_date=$now WHERE u_id='". (int)$this->forumUser->userId . "'";
      if(!$conn->Execute($sql2)) die(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
    }
    else {
      $sql2 = "INSERT INTO ". $this->forumSettings->sql_userLog_table ." (u_id, last_login_date, lu_user, lu_date) VALUES('". $this->forumUser->userId . "', $now, 'SYSTEM', $now)";
      $this->forumUser->last_login_date = $now;
      if(!$conn->Execute($sql2)) die(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
    }
  }
	
  /*********************************************
   * Tell the forum what action to undertake next
   ***/
  function action($vars) {
    extract($vars);
    $this->initUser();
    $this->unsetObjects();
    if(isset($errMsg)) $this->smarty->assign("errorMsg", $this->langText["errorMsg_". $errMsg]);

    // we grab the icon-id directly from MGW object, because i want to
    // have the new selected icons immediatly, not after session destroy
    // same for iconmode (on/off)
    // * in the future all settings should be grabbed directly from $MGW->settings
    // and not from the forum->settings object (loge!)
    $this->smarty->assign("iconset", $this->forumSettings->iconset);
    $this->smarty->assign("with_icons", $this->forumSettings->with_icons);
		
    switch($action) {
    case "list_groups" :
      $this->listGroups($frm_id);
      break;
    case "list_threads" :
      $this->current_TPL = "list_threads";
      $this->listThreads($frm_id, $pageNum);
      break;
    case "show_thread" :
      $this->current_TPL = "list_replies";
      $this->showThread($frm_id, $thread_id, $pageNum);
      break;
    case "new_thread" :
      $this->current_TPL = "new_thread";
      $this->newThread($vars);
      break;
    case "reply_thread" :
      $this->current_TPL = "new_thread";
      $this->replyThread($vars);
      break;
    case "edit_thread" :
      $this->editThread($vars);
      break;
    case "delete_thread" :
      $this->deleteThread($vars);
      break;
    case "save_new_thread" :
      if(isset($n_thread_preview) && $n_thread_preview == true) {
	$this->current_TPL = "new_preview";
	$this->preview($vars);
      }
      else {
	$this->current_TPL = "thread_saved";
	$this->saveNewThread($vars);
      }
      break;
    default :
      $this->current_TPL = "list_groups";
      $this->listGroups();
      break;
    }
  }

  /*****************************************************************************
   * Get the forum groups out of the groups table and fill the group objects.
   * Append all objects to the forum groups array to be retrieved later by smarty.
   ***/
  function listGroups() {
    global $conn;
    unset($this->forumGroups);
    $this->regArray("forumForums");
    $this->setSmartyCheck("forumForums", "list_groups", true);
    $count1 = 0;
    $noGroups = false;

    $sql_grp = "SELECT grp_id AS n_grp_id, grp_name AS n_grp_name, grp_desc AS n_grp_desc FROM ". $this->forumSettings->sql_grp_table;

    if(!$res_grp = $conn->Execute($sql_grp)) die(showSQLerror($sql_grp, $conn->ErrorMsg(), __LINE__, __FILE__));
    $numRows = $res_grp->RecordCount();
    if ($numRows == 0) {
      $numRows = 1;
      $row_grp["n_grp_id"] = 0;
      $noGroups = true;
    }
    for ($i = 0; $i < $numRows; $i++){
      if($noGroups == false) {
	$row_grp = $res_grp->FetchRow();
	//create forumGroup object and put into the groups array
	$this->regObject("forumGroup", "forumGroup", false, true);
	// check in the sql array to be distributed to all waiting objects
	// should be going to the forumGroups object.
	$this->checkIn("SQL", $row_grp);
	// once the forumGroups object has received its data, add it to the forumGroups array
	$this->appendArray("forumForums", $this->forumGroup);
	//$this->forumGroup->printAll();
      }
      /************************************
       * Retrieve all forums of the selected
       * group.
       ***/
      if ($this->forumUser->threads_lastDays=="0") $thread_lastDays_in_sec = time() - mktime(0,0,0,date("m",time()) ,date("d",time()) ,date("Y",time()) );
      else $thread_lastDays_in_sec = $this->forumUser->threads_lastDays*3600*24;
      $sql_frm = "SELECT
SUM( CASE WHEN ((b.reply_id=0) AND (b.thread_date > ".$conn->DBTimeStamp(time() - $thread_lastDays_in_sec).")) THEN 1 ELSE 0 END) AS n_frm_num_threads,
SUM( CASE WHEN ((b.thread_id!=0) AND (b.thread_date > ".$conn->DBTimeStamp(time() - $thread_lastDays_in_sec).")) THEN 1 ELSE 0 END) AS n_frm_num_posts,
CASE WHEN (SUM( CASE WHEN b.thread_id IS NULL THEN 0 ELSE 1 END) > SUM( CASE WHEN ". $this->forumUser->last_login_date ." > b.thread_date THEN 1 ELSE 0 END)) THEN 'NEW_MESSAGES' ELSE 'NO_NEW_MESSAGES' END AS n_frm_new_posts,
CASE WHEN (SUM( CASE WHEN b.thread_id IS NULL THEN 0 ELSE 1 END) > SUM( CASE WHEN ". $this->forumUser->last_login_date ." > b.thread_date THEN 1 ELSE 0 END)) THEN '". $this->forumSettings->grpLst_newThreadIcon ."' ELSE '". $this->forumSettings->grpLst_noNewThreadIcon ."' END AS n_frm_new_posts_image,
MAX(b.thread_date) AS last_thread_date, a.frm_id AS n_frm_id,
a.frm_name AS n_frm_name,
a.frm_info AS n_frm_info,
a.frm_rightsLevel AS n_frm_rightslevel
FROM ". $this->forumSettings->sql_frm_table ." a
LEFT JOIN ". $this->forumSettings->sql_thread_table ." b ON a.frm_id=b.frm_id
WHERE a.grp_id='". $row_grp["n_grp_id"] ."'
GROUP BY a.frm_id, a.frm_name, a.frm_info, a.frm_rightsLevel";

      if(!$res_frm = $conn->Execute($sql_frm)) die(showSQLerror($sql_frm, $conn->ErrorMsg(), __LINE__, __FILE__));
      while($row = $res_frm->FetchRow()){
	/******************************************
	 * Retrieve the last thread of this group
	 ***/
	if ($row["n_frm_num_threads"] > 0) {
	  $concat = $conn->Concat("'". $this->langText["by"] ." '", 'b.username');
	  $sql2 = "SELECT CASE WHEN b.username IS NULL THEN 'unknown' ELSE $concat END AS n_frm_last_entry_author, a.thread_date AS frm_last_entry_date, a.thread_title AS n_frm_last_entry_title FROM ". $this->forumSettings->sql_thread_table ." a LEFT JOIN ". $this->forumSettings->sql_user_table ." b ON a.author_id=b.id WHERE a.thread_date='". $row["last_thread_date"] ."' AND thread_date >= ".$conn->DBTimeStamp(time() - $thread_lastDays_in_sec);
	  if(!$res2 = $conn->Execute($sql2)) die(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
	  $row2 = $res2->FetchRow();

	  if($row2["n_frm_last_entry_title"] == "") {
	    $row["n_frm_last_entry_title"] = $this->langText["no_threads"];
	    $row["n_frm_num_threads"] = 0;
	    $row["n_frm_num_posts"] = 0;
	  }
	  else {
	    $row2["n_frm_last_entry_title"] = $this->formatText($row2["n_frm_last_entry_title"], "title"); 
	    $row2["n_frm_last_entry_date"] = date($this->forumSettings->date_format, $res2->UnixTimeStamp($row2["frm_last_entry_date"]));
	  }
	}
	else{
	    $row2["n_frm_last_entry_title"] = $this->langText["no_threads"];
	    $row2["n_frm_num_threads"] = 0;
	    $row2["n_frm_num_posts"] = 0;
	    $row2['n_frm_last_entry_author'] = '';
	}
	/******************************************
	 * Retrieve all the moderators of this group
	 * The administrator may switch this function off!
	 ***/
	if($this->forumSettings->with_moderators > 0) {
	  $sql3 = "SELECT * FROM ". $this->forumSettings->sql_moderator_table ." a LEFT JOIN ". $this->forumSettings->sql_user_table ." b ON a.u_id = b.id WHERE a.frm_id='". $row["n_frm_id"] ."'";
	  if(!$res3 = $conn->Execute($sql3)) die(showSQLerror($sql3, $conn->ErrorMsg(), __LINE__, __FILE__));

	  $count2 = 0;
	  $moderators = "";
	  while($row3 = $res3->FetchRow()){
	    // whilst retrieving all the moderators for each group,
	    // add the groups that the user moderates to the user object
	    if($row3["id"] == $this->forumUser->userId) {
	      $count1 > 0 ? $moderateGroups .= ";". $row["n_frm_id"] : $moderateGroups .= $row["n_frm_id"];
	      $count1++;
	    }
	    // retrieve the moderators for each group
	    $count2 > 0 ? $moderators .= ", ". $row3["username"] : $moderators .= $row3["username"];
	    $count2++;
	  }
	  // add moderators to array
	  $row["n_frm_moderators"] = $moderators;
	}
	else {
	  $this->smarty->assign("with_moderators", "false");
	}
	// merge both sql-arrays together for the group object
	$frm_row = array_merge($row, $row2);
	//create forumGroup object and put into the groups array
	$this->regObject("forumForum", "forumForum", false, true);
	// check in the sql array to be distributed to all waiting objects
	// should be going to the forumGroups object.
	$this->checkIn("SQL", $frm_row);
	// once the forumGroups object has received its data, add it to the forumGroups array
	$this->appendArray("forumForums", $this->forumForum);
      }
    }
    // add the groups that the user moderates to the user object
    $this->forumUser->moderatorOfGrp = $moderateGroups;
  }

  /**********************************
   *  List all threads of a particular group
   ***/
  function listThreads($frm_id, $pageNum) {
    global $conn;
    unset($this->forumThreads);
    unset($this->forumPages);

    /****************************************
     * Does the user have the necessary rights
     * to view this group?
     ***/
    $check = $this->checkGrpRights($frm_id);
    if($check == false) {
      redirect("index.php?errMsg=PD&".SID);
    }
    else {
      // set the smarty check for automatic appending to the templates
      $this->regArray("forumThreads");
      $this->regArray("forumPages");
      $this->smarty->assign("frm_id", $frm_id);
      $this->setSmartyCheck("forumThreads", "list_threads;list_replies", true);
      $this->setSmartyCheck("forumPages",	"list_threads;list_replies", true);

      // count the number of threads for working out the number of pages
      $sql = "SELECT frm_id FROM ". $this->forumSettings->sql_thread_table ." WHERE frm_id='". (int)$frm_id ."' AND reply_id='0' AND thread_date >= ".$conn->DBTimeStamp(time() - $this->forumUser->threads_lastDays*3600*24);
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
		
      $mycount = $res->RecordCount();
			
      $numPages = ceil($mycount/$this->forumUser->numThreads);
      if($numPages > 0 && !isset($pageNum)) {
	$pageNum = $numPages - 1;
      }

      $sql = "SELECT a.*, a.thread_date AS thread_date_, b.username AS thread_author FROM ". $this->forumSettings->sql_thread_table ." a LEFT JOIN ". $this->forumSettings->sql_user_table ." b ON a.author_id=b.id WHERE  a.frm_id='". (int)$frm_id ."' AND thread_date >= ".$conn->DBTimeStamp(time() - $this->forumUser->threads_lastDays*3600*24)." ORDER BY thread_id ASC, reply_id DESC";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      $maxRows = $res->RecordCount();
		
      if(isset($pageNum)) {
	$pageStart = $this->forumUser->numThreads * $pageNum;
	$pageEnd = $pageStart + $this->forumUser->numThreads;
      }
      else {
	$pageStart = 0;
	$pageEnd = $this->forumUser->numThreads;
      }
	
      $numReplies = 0;
      $count = 0;
      while($row = $res->FetchRow()){
	/* ADD TOGETHER THE NUMBER OF REPLIES */
	if($row["reply_id"] > 0) $numReplies++;
	/* RETRIEVE ALL THE DATA AND PREPARE FOR FORUM.MESSAGE OBJECT */
	if($row["reply_id"] == 0) {
	  /* CALCULATE THE NUMBER OF VIEWS PER THREAD */
	  $sql2 = "SELECT a.*, CASE WHEN ". $this->forumUser->last_login_date ." > a.thread_date THEN 0 ELSE 1 END AS viewed_status FROM ". $this->forumSettings->sql_thread_table ." a WHERE a.frm_id='". (int)$frm_id ."' AND a.thread_id='". $row["thread_id"] ."'
						";
	  if(!$res2 = $conn->Execute($sql2)) die(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
	  while($row2 = $res2->FetchRow()) {
	    if($row2["viewed_status"] > 0) {
	      $userView++; 
	    }
	  }
	  $userView > 0 ? $thread["n_thread_viewed"] = "NOT_VIEWED" : $thread["n_thread_viewed"] = "VIEWED";
	  $userView > 0 ? $thread["n_thread_viewed_image"] = $this->forumSettings->threadLst_notViewedIcon : $thread["n_thread_viewed_image"] = $this->forumSettings->threadLst_viewedIcon;
	  $thread["n_thread_id"] 					= $row["thread_id"];
	  $thread["n_frm_id"] 						= $row["frm_id"];
	  $thread["n_reply_id"] 					= $row["reply_id"];
	  $thread["n_thread_author_id"]		= $row["author_id"];
	  $thread["n_thread_header"] 			= $this->formatText($row["thread_title"], "title");
	  $thread["n_thread_author"] 			= $row["thread_author"];
	  $thread["n_thread_smiley"] 			= $row["thread_smiley"];
	  $thread["n_thread_date"] 				= date($this->forumSettings->date_format, $res->UnixTimeStamp($row["thread_date_"]));
	  $thread["n_thread_num_views"]		= $row["thread_views"];
	  $thread["n_thread_num_replies"]	= $numReplies;
	  $numReplies = 0;
	  $numViews = 0;
	  $userView = 0;
	}			
	
	if($row["reply_id"] == 0) {
	  if($count >= $pageStart && $count < $pageEnd) {
	    //create forumGroup object and put into the groups array
	    $this->regObject("forumThread", "forumThread", false, true);
	    // check in the sql array to be distributed to all waiting objects
	    // should be going to the forumGroups object.
	    $this->checkIn("SQL", $thread);
	    // once the forumGroups object has received its data, add it to the forumGroups array
	    $this->appendArray("forumThreads", $this->forumThread);
	    //$this->forumThread->printAll();
	  }
	  $count++;
	}
      }

      // PREVIOUS
      if(($pageStart - $this->forumUser->numThreads) >= 0) {
	$this->regObject("forumPage", "forumPage", false, false);
	$this->forumPage->setVar("pageTitle", $this->langText["previous"]);
	$this->forumPage->setVar("pageNum", $pageNum);
	$this->forumPage->setVar("pageUrl", "index.php?action=list_threads&frm_id=". $frm_id ."&pageNum=". ($pageNum-1) ."&".SID);
	$this->appendArray("forumPages", $this->forumPage);
      }
      // PAGE NUMBERS
      for($i=0; $i < $numPages; $i++) {
	$this->regObject("forumPage", "forumPage", false, false);
	$i == $pageNum ? $this->forumPage->setVar("pageSelected", "true") : $this->forumPage->setVar("pageSelected", "false");
	$this->forumPage->setVar("pageTitle", $i+1);
	$this->forumPage->setVar("pageNum", $i);
	$this->forumPage->setVar("pageUrl", "index.php?action=list_threads&frm_id=". $frm_id ."&pageNum=". $i ."&".SID);
	$this->appendArray("forumPages", $this->forumPage);
      }
      // NEXT
      if(($pageStart + $this->forumUser->numThreads) < $count) {
	$this->regObject("forumPage", "forumPage", false, false);
	$this->forumPage->setVar("pageTitle", $this->langText["next"]);
	$this->forumPage->setVar("pageNum", $pageNum + 1);
	$this->forumPage->setVar("pageUrl", "index.php?action=list_threads&frm_id=". $frm_id ."&pageNum=". ($pageNum+1) ."&".SID);
	$this->appendArray("forumPages", $this->forumPage);
      }
    }
  }

  function showThread($frm_id, $thread_id, $pageNum) {
    /****************************************
     * Does the user have the necessary rights
     * to view this group?
     ***/
    $check = $this->checkGrpRights($frm_id);
    if($check == false) {
      redirect("index.php?errMsg=PD");
    }
    else {
      global $conn;
      unset($this->forumThreads);
      unset($this->forumPages);
      $this->regArray("forumThreads");
      $this->regArray("forumPages");
      $this->setSmartyCheck("forumThreads",	"list_threads;list_replies", true);
      $this->setSmartyCheck("forumPages",	"list_threads;list_replies", true);
      $this->smarty->assign("frm_id", $frm_id);
      $this->smarty->assign("thread_id", $thread_id);

      $this->forumSettings->with_userLogo > 0 ? $this->smarty->assign("with_userLogo", "true") : 	$this->smarty->assign("with_userLogos", "false");
      $this->forumSettings->with_signature > 0 ? $this->smarty->assign("with_signature", "true") : 	$this->smarty->assign("with_signature", "false");
      //$this->forumUser->printAll();
      $sql = "SELECT MAX(reply_id) AS max_reply_id, MAX(thread_views) AS num_thread_views FROM ". $this->forumSettings->sql_thread_table ." WHERE frm_id='". (int)$frm_id ."' AND thread_id='". (int)$thread_id ."'";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

      $mycount = $res->RecordCount();
			
      if($row = $res->FetchRow()){
	$numPages = ceil($mycount/$this->forumUser->numThreads);
	$maxReplyId = $row["max_reply_id"];
	$views = $row["num_thread_views"] + 1;
	if($numPages > 0 && !isset($pageNum)) {
	  $pageNum = $numPages - 1;
	}
      }


      /**************************************
       * Retrieve all the threads for the 
       * particular frm_id and thread_id.
       ***/
      $sql = "SELECT 
							a.frm_id AS n_frm_id,
							a.thread_id AS n_thread_id,
							a.reply_id AS n_reply_id,
							a.author_id AS n_thread_author_id,
							a.thread_title AS n_thread_header,
							a.thread_text AS n_thread_text,
							a.thread_smiley AS n_thread_smiley,
							a.thread_date AS thread_date,
							a.thread_date AS thread_date,
							a.thread_modifiedBy AS n_thread_modified_by,
							a.thread_modifiedDate AS n_thread_modified_date,
							b.username AS n_thread_author,
							b.email AS n_thread_email,
							a.thread_views,
							a.thread_rightslevel AS n_thread_rightslevel,
							c.value_txt AS n_user_signature,
CASE WHEN (d.value_str='' OR d.value_str IS NULL) THEN 'nopic' ELSE 'pic' END AS n_user_logo,
CASE WHEN ". $this->forumUser->last_login_date ." > a.thread_date THEN 'VIEWED' ELSE 'NOT_VIEWED' END AS n_thread_viewed,
CASE WHEN ". $this->forumUser->last_login_date ." > a.thread_date THEN '". $this->forumSettings->threadLst_viewedIcon ."' ELSE '". $this->forumSettings->threadLst_notViewedIcon ."' END AS n_thread_viewed_image 
							FROM
							". $this->forumSettings->sql_thread_table ." a
							LEFT JOIN
							". $this->forumSettings->sql_user_table ." b
							ON a.author_id=b.id
							LEFT JOIN
							". $this->forumSettings->sql_user_settings_table ." c
							ON a.author_id=c.userid
							AND c.configtagname='forum_signature'
							LEFT JOIN
							". $this->forumSettings->sql_user_settings_table ." d
							ON a.author_id=d.userid
							AND d.configtagname='forum_mylogo'
							WHERE a.frm_id='". (int)$frm_id ."'
							AND a.thread_id='". (int)$thread_id ."'
						";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      $maxRows = $res->RecordCount();
      if(isset($pageNum)) {
	$pageStart = $this->forumUser->numReplies * $pageNum;
	$pageEnd = $pageStart + $this->forumUser->numReplies;
      }
      else {
	$pageStart = 0;
	$pageEnd = $this->forumUser->numReplies;
      }
      $count = 0;
      while($row = $res->FetchRow()){
	$row["n_thread_date"] = date($this->forumSettings->date_format, $res->UnixTimeStamp($row["thread_date"]));
				
	/******************************************
	 * What rights does the user have?
	 * If he is a moderator, is he the moderator
	 * of this group?
	 ***/
	$moderate = 0;
	if($_SESSION['MGW']->userid == 1){
	  // the admin can edit and delete all threads
	  $row["n_thread_allowDelete"] = "true";
	  $row["n_thread_allowEdit"] = "true";
	}
	else{
	  $expGroups = explode(";", $this->forumUser->moderatorOfGrp);
	  for($i = 0; $i < count($expGroups); $i++) {
	    if($expGroups[$i] == $frm_id) $moderate++;
	  }
	  if($moderate > 0 && $this->forumSettings->with_moderators > 0 && $row["n_thread_rightslevel"] != 9) {
	    $row["n_thread_allowEdit"] = "true";
	  }
	  else {
	    $row["n_thread_allowEdit"] = "false";
	  }
	}

			
	/***
	 * End rights check
	 *********************************************/
	if($row["n_reply_id"] == 0) {
	  $doViewsUpdate = true;
	  $date = $row["thread_date"];
	}
	if($count >= $pageStart && $count < $pageEnd) {
	  //create forumGroup object and put into the groups array
	  $this->regObject("forumThread", "forumThread", false, true);
	  // check in the sql array to be distributed to all waiting objects
	  // should be going to the forumGroups object.
	  $this->checkIn("SQL", $row);
	  $this->forumThread->setVar("thread_text",	$this->formatText($row["n_thread_text"], "text"));
	  $this->forumThread->setVar("thread_header",	$this->formatText($row["n_thread_header"], "title"));
	  $this->forumThread->setVar("user_signature",	$row["n_user_signature"]);
	  // once the forumGroups object has received its data, add it to the forumGroups array
	  $this->appendArray("forumThreads", $this->forumThread);
	  //$this->forumThread->printAll();
	}
	$count++;

      }
      /****************************************
       * Set up the page links for the template
       ***/
	
      //$numPages = ceil($maxRows/$this->forumUser->numReplies);
      // PREVIOUS
      if(($pageStart - $this->forumUser->numReplies) >= 0) {
	$this->regObject("forumPage", "forumPage", false, false);
	$this->forumPage->setVar("pageTitle", $this->langText["previous"]);
	$this->forumPage->setVar("pageNum", $pageNum);
	$this->forumPage->setVar("pageUrl", "index.php?action=show_thread&frm_id=". $frm_id ."&thread_id=". $thread_id ."&pageNum=". ($pageNum-1) ."&".SID);
	$this->appendArray("forumPages", $this->forumPage);
      }
      // PAGE NUMBERS
      for($i=0; $i < $numPages; $i++) {
	$this->regObject("forumPage", "forumPage", false, false);
	$i == $pageNum ? $this->forumPage->setVar("pageSelected", "true") : $this->forumPage->setVar("pageSelected", "false");
	$this->forumPage->setVar("pageTitle", $i+1);
	$this->forumPage->setVar("pageNum", $i);
	$this->forumPage->setVar("pageUrl", "index.php?action=show_thread&frm_id=". $frm_id ."&thread_id=". $thread_id ."&pageNum=". $i ."&".SID);
	$this->appendArray("forumPages", $this->forumPage);
      }
      // NEXT
      if(($pageStart + $this->forumUser->numReplies) < $maxRows) {
	$this->regObject("forumPage", "forumPage", false, false);
	$this->forumPage->setVar("pageTitle", $this->langText["next"]); 
	$this->forumPage->setVar("pageNum", $pageNum + 1);
	$this->forumPage->setVar("pageUrl", "index.php?action=show_thread&frm_id=". $frm_id ."&thread_id=". $thread_id ."&pageNum=". ($pageNum+1) ."&".SID);
	$this->appendArray("forumPages", $this->forumPage);
      }
      if($doViewsUpdate == true) {
	$sql = "UPDATE ". $this->forumSettings->sql_thread_table ." SET thread_date='". $date ."', thread_views='". $views ."' WHERE frm_id='". (int)$frm_id ."' AND thread_id='". (int)$thread_id ."' AND reply_id='0'";
	if(!$conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      }
    }
  }	

  function newThread($vars) {
    extract($vars);
    global $conn;
    $this->smarty->assign("thread_type", "new");
    $this->smarty->assign("with_email_notify", $this->forumSettings->with_email_notify > 0 ? "true" : "false");

    /******************************************************
     * If the user decides to make changes after having seen 
     * the preview, put all his values back into the fields.
     ***/
    if($mode == "back") {
      $this->smarty->assign("frm_id", 			$this->forumThread->frm_id);
      $this->smarty->assign("thread_id", 		$this->forumThread->thread_id);
      $this->smarty->assign("reply_id", 		$this->forumThread->reply_id);
      $this->smarty->assign("thread_smiley", 			$this->forumThread->thread_smiley);
      $this->smarty->assign("preview", 			$this->forumThread->thread_preview);
      $this->smarty->assign("thread_emailOnReply", $this->forumThread->thread_emailOnReply);
      $this->smarty->assign("thread_text",	$this->forumThread->thread_text);
      $this->smarty->assign("origTitle", 		$this->forumThread->thread_header);
    }
    /**************************************************
     * Pass the default values on to the smarty template 
     ***/
    else {
      $this->smarty->assign("frm_id", $frm_id);
      $this->smarty->assign("thread_smiley", $this->forumSettings->def_thread_smiley);
      $this->smarty->assign("preview", $this->forumSettings->def_thread_preview);
      $this->smarty->assign("thread_emailOnReply", $this->forumSettings->def_thread_emailOnReply);
    }
		
    $smileys = $this->getSmileys();
    for($i=0; $i < count($smileys);$i++) {
      $this->smarty->append("smileys", $smileys[$i]);
    }
  }

  /***********************************************
   * Reply to a thread.
   * @param int frm_id
   * @param int thread_id
   * @param int reply_id
   * @param String mode (back = edit after preview)
   ***/
  function replyThread($vars) {
    extract($vars);
    global $conn;
    $this->smarty->assign("thread_type", "reply");
    $this->smarty->assign("with_email_notify", $this->forumSettings->with_email_notify > 0 ? "true" : "false");
		
    /******************************************************
     * If the user decides to make changes after having seen 
     * the preview, put all his values back into the fields.
     ***/
    if(isset($mode) && $mode == "back") {
      $this->smarty->assign("frm_id", 			$this->forumThread->frm_id);
      $this->smarty->assign("thread_id", 		$this->forumThread->thread_id);
      $this->smarty->assign("reply_id", 		$this->forumThread->reply_id);
      $this->smarty->assign("thread_smiley",$this->forumThread->thread_smiley);
      $this->smarty->assign("preview", 			$this->forumThread->thread_preview);
      $this->smarty->assign("thread_emailOnReply", $this->forumThread->thread_emailOnReply);
      $this->smarty->assign("thread_text",	$this->forumThread->thread_text);
      $origTitle = str_replace("re: ", "",	$this->forumThread->thread_header);
      $this->smarty->assign("origTitle", 		$origTitle);
    }
    /**************************************************
     * Pass the default values on to the smarty template 
     ***/
    else {
      $this->smarty->assign("frm_id", 			$n_frm_id);
      $this->smarty->assign("thread_id", 		$n_thread_id);
      $this->smarty->assign("reply_id",	 		$n_reply_id);
      $this->smarty->assign("thread_smiley", 			$this->forumSettings->def_thread_smiley);
      $this->smarty->assign("preview", 			$this->forumSettings->def_thread_preview);
      $this->smarty->assign("thread_emailOnReply", $this->forumSettings->def_thread_emailOnReply);
			
      /*******************************************
       * Retrieve message header and pass on as re:
       ***/
      $n_reply_id > 0 ? $addWhere = $n_reply_id : $addWhere = 0;
      $sql = "SELECT * FROM ". $this->forumSettings->sql_thread_table ." 
							WHERE frm_id='". (int)$n_frm_id ."' 
							AND thread_id='". (int)$n_thread_id ."'
							AND reply_id='". (int)$addWhere ."'
						";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      if($row = $res->FetchRow()){
	$origTitle = str_replace("re: ", "", htmlspecialchars($row["thread_title"]));
	$this->smarty->assign("origTitle", $origTitle);
      }
    }
    /********************************************
     * Get array of smileys and pass on to smarty.
     ***/
    $smileys = $this->getSmileys();
    for($i=0; $i < count($smileys);$i++) {
      $this->smarty->append("smileys", $smileys[$i]);
    }
  }

  /*******************************
   * Preview reply or new thread.
   * @param assoc array $HTTP_VARS
   ***/
  function preview($vars) {
    extract($vars);
        
    $this->regObject("forumThread", "forumThread", true, true);

    $this->forumThread->checkIn("HTTP");
    $this->forumThread->setVar("thread_text",	$this->formatText($n_thread_text, "text"));
    $this->forumThread->setVar("thread_header",	$this->formatText($n_thread_header, "title"));
    //$this->forumThread->printAll();
    $this->smarty->assign("hidden_thread_header", htmlspecialchars($n_thread_header));
    $this->smarty->assign("hidden_thread_text", htmlspecialchars($n_thread_text));
    $this->smarty->assign("forumThread", $this->forumThread);

  }

  /*******************************
   * Save thread.
   * @param assoc array $HTTP_VARS
   ***/
  function saveNewThread($vars) {
    extract($vars);
    global $conn;

    $n_thread_emailOnReply == "on" ? $thread_emailOnReply = 1 : $thread_emailOnReply = 0;

    switch($n_thread_type) {
    case "new" :
      $this->smarty->assign("frm_id", $n_frm_id);
      $sql = "SELECT MAX(thread_id) AS last_thread FROM  ". $this->forumSettings->sql_thread_table ." WHERE frm_id='". (int)$n_frm_id ."'";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      $row = $res->FetchRow();
      $n_thread_id = $row["last_thread"] + 1;
      if ($n_thread_header != "" and $n_thread_text != "") {
	  $sql = "INSERT INTO ".$this->forumSettings->sql_thread_table ." (frm_id,thread_id, reply_id, author_id, thread_title,thread_text, thread_smiley, thread_date, thread_views,thread_emailOnReply, thread_rightsLevel, lu_user,lu_date, thread_modifieddate, thread_modifiedby) VALUES('".(int)$n_frm_id ."', '". (int)$n_thread_id ."', '0', '".$this->forumUser->userId ."', ".$conn->QMagic($n_thread_header) .", ".$conn->QMagic($n_thread_text) .", '". $n_thread_smiley."', NOW(), '0', '". $thread_emailOnReply ."', '".(int)$this->forumUser->userLevel ."', 'SYSTEM', NOW(),NOW(),'".$this->forumUser->userName."')";
      }

      if(!$conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      break;
    case "reply" :
      // send off email that someone has replied.
      // the Administrator may switch this off!
      if($this->forumSettings->with_email_notify > 0) {
	$sql3 = "SELECT DISTINCT
										b.id,
										b.email,
										b.firstname
										FROM ". $this->forumSettings->sql_thread_table ." a 
										LEFT JOIN ". $this->forumSettings->sql_user_table ." b 
										ON b.id=a.author_id 
										WHERE 
										a.frm_id='". (int)$n_frm_id ."'
										AND a.thread_id='". (int)$n_thread_id ."' 
										AND a.thread_emailOnReply > 0
									";
	if(!$res3 = $conn->Execute($sql3)) die(showSQLerror($sql3, $conn->ErrorMsg(), __LINE__, __FILE__));
	while($row3 = $res3->FetchRow()){
	  // make sure that the replier doesn't get the mail aswell!
	  if($row3["id"] != $this->forumUser->userId) {
	    $this->sendMail($row3["email"], $row3["firstname"], $this->forumUser->forename, $n_frm_id, $n_thread_id);
	  }
	}
      }
      $sql = "SELECT MAX(reply_id) AS maxreply FROM ". $this->forumSettings->sql_thread_table ." WHERE thread_id='". (int)$n_thread_id ."' AND frm_id='". (int)$n_frm_id ."'";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      $row = $res->FetchRow();

      if ($n_thread_header != "" and $n_thread_text != "") {
	  $sql2 = "INSERT INTO ".$this->forumSettings->sql_thread_table ." (frm_id,thread_id, reply_id, author_id, thread_title,thread_text, thread_smiley, thread_date,thread_emailOnReply, thread_rightsLevel, lu_user,lu_date, thread_modifieddate, thread_modifiedby, thread_views) VALUES('".(int)$n_frm_id ."', '". (int)$n_thread_id ."', '".($row["maxreply"] + 1) ."', '".$this->forumUser->userId ."', ".$conn->QMagic($n_thread_header) .", ".$conn->QMagic($n_thread_text) .", '". $n_thread_smiley."', NOW(), '". $thread_emailOnReply ."', '".$this->forumUser->userLevel ."', 'SYSTEM', NOW(),NOW(),'".$this->forumUser->userName."','0')";
	  if(!$conn->Execute($sql2)) die(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
      }
      break;
    case "edit":
			
      if ($n_thread_header != "" and $n_thread_text != "") {
	$sql = "UPDATE ". $this->forumSettings->sql_thread_table ." 
							SET thread_title=". $conn->QMagic($n_thread_header) .", 
							thread_text=". $conn->QMagic($n_thread_text) .", 
							thread_modifiedBy='". $this->forumUser->userName ."',
							thread_modifiedDate=NOW() 
							WHERE frm_id='". (int)$n_frm_id ."' AND thread_id='". (int)$n_thread_id ."' AND reply_id='". (int)$n_reply_id ."'
						";
	if(!$conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      }
      break;
    }
    $this->smarty->assign("frm_id", $n_frm_id);
    $this->smarty->assign("thread_id", $n_thread_id);
    redirect("index.php?action=show_thread&frm_id=$n_frm_id&thread_id=$n_thread_id&".SID);
  }
	
  function editThread($vars) {
    extract($vars);
    global $conn;

    $this->smarty->assign("thread_type", "edit");
    $this->smarty->assign("with_email_notify", $this->forumSettings->with_email_notify > 0 ? "true" : "false");
    /******************************************************
     * If the user decides to make changes after having seen 
     * the preview, put all his values back into the fields.
     ***/
    if($mode == "back") {
      // does the user have pemission to edit the thread?
      $checkRights = $this->checkPermission($this->forumThread->frm_id, $this->forumThread->thread_id, $this->forumThread->reply_id, "edit");
      if($checkRights == true) {
	$this->current_TPL = "new_thread";
	$this->smarty->assign("frm_id", 			$this->forumThread->frm_id);
	$this->smarty->assign("thread_id", 		$this->forumThread->thread_id);
	$this->smarty->assign("reply_id", 		$this->forumThread->reply_id);
	$this->smarty->assign("thread_author_id",$this->forumThread->thread_author_id);
	$this->smarty->assign("thread_smiley",$this->forumThread->thread_smiley);
	$this->smarty->assign("preview", 			$this->forumThread->thread_preview);
	$this->smarty->assign("thread_emailOnReply", $this->forumThread->thread_emailOnReply);
	$this->smarty->assign("thread_text",	$this->forumThread->thread_text);
	$origTitle = str_replace("re: ", "",	$this->forumThread->thread_header);
	$this->smarty->assign("origTitle", 		$origTitle);
	//				$this->forumThread->printAll();
      }
      else {
	$this->smarty->assign("denied_type", "edit");
	$this->current_TPL = "permission_denied";
      }
    }
    /**************************************************
     * Pass the default values on to the smarty template 
     ***/
    else {
      // does the user have pemission to edit the thread?
      $checkRights = $this->checkPermission($n_frm_id, $n_thread_id, $n_reply_id, "edit");
      if($checkRights == true) {
	$this->current_TPL = "new_thread";
	$this->smarty->assign("frm_id", 			$n_frm_id);
	$this->smarty->assign("thread_id", 		$n_thread_id);
	$this->smarty->assign("reply_id",	 		$n_reply_id);
	$this->smarty->assign("preview", 			$this->forumSettings->def_thread_preview);
				
	/*******************************************
	 * Retrieve message data
	 ***/
	$n_reply_id > 0 ? $addWhere = $n_reply_id : $addWhere = 0;
	$sql = "SELECT * FROM ". $this->forumSettings->sql_thread_table ." 
								WHERE frm_id='". (int)$n_frm_id ."' 
								AND thread_id='". (int)$n_thread_id ."'
								AND reply_id='". (int)$addWhere ."'
							";
	if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	if($row = $res->FetchRow()){
	  $this->smarty->assign("thread_author_id", $row["author_id"]);
	  $this->smarty->assign("origTitle", htmlspecialchars($row["thread_title"]));
	  $this->smarty->assign("thread_text", htmlspecialchars(str_replace("re: ", "", $row["thread_text"])));
	  $this->smarty->assign("thread_smiley", 			$row["thread_smiley"]);
	  $row["thread_emailOnReply"] == 1 ? $thread_emailOnReply = "on" : $thread_emailOnReply = "";
	  $this->smarty->assign("thread_emailOnReply", $thread_emailOnReply);
	}
      }
      else {
	$this->smarty->assign("denied_type", "edit");
	$this->current_TPL = "permission_denied";
      }
    }
    /********************************************
     * Get array of smileys and pass on to smarty.
     ***/
    $smileys = $this->getSmileys();
    for($i=0; $i < count($smileys);$i++) {
      $this->smarty->append("smileys", $smileys[$i]);
    }
  }
	
  /**********************************
   * function for deleting replies or
   * entire threads.
   ***/
  function deleteThread($vars) {
    extract($vars);
    global $conn;
    $this->smarty->assign("frm_id", $n_frm_id);
    $this->smarty->assign("thread_id", $n_thread_id);
    $this->smarty->assign("reply_id", $n_reply_id);

    // does the user have pemission to delete the thread?
    $checkRights = $this->checkPermission($n_frm_id, $n_thread_id, $n_reply_id, "delete");
    if($checkRights == true) {
      if($cmd == "go") {
	$this->current_TPL = "delete_thread";
	$this->smarty->assign("message_type", "thread_deleted");
	if($n_reply_id == "0") {
	  /*************************************
	   * if the whole thread is to be deleted
	   ***/
	  $this->smarty->assign("back_type", "thread_overview");
	  $this->smarty->assign("back_text", $this->langText["label_back_to_threads"]);
	  $sql = "DELETE FROM ". $this->forumSettings->sql_thread_table ." WHERE frm_id='". (int)$n_frm_id ."' AND thread_id='". (int)$n_thread_id ."'";
	  if(!$conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	}		
	else {
	  /****************************
	   * if a reply is to be deleted
	   ***/
	  $this->smarty->assign("back_type", "thread");
	  $this->smarty->assign("back_text", $this->langText["label_back_to_thread"]);
	  $sql = "DELETE FROM ". $this->forumSettings->sql_thread_table ." WHERE frm_id='". (int)$n_frm_id ."' AND thread_id='". (int)$n_thread_id ."' AND reply_id='". (int)$n_reply_id ."'";
	  if(!$conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	}
      }
      else {
	$this->current_TPL = "delete_thread";
	$this->smarty->assign("message_type", "really_delete");
      }
    }
    else {
      $this->smarty->assign("denied_type", "delete");
      $this->current_TPL = "permission_denied";
    }
  }
	
  /**********************************
   * Get all of the smileys that exist
   * in the smileys folder.
   * @return array Smileys
   ***/
  function getSmileys() {
    $dir = dir("media/smileys/");
    while($file=$dir->read()) {
      if(is_file("media/smileys/". $file)) {
	$smileys[] = $file;
      }
    }
    return $smileys;
  }
	
  /************************************************
   * This function checks if the user has permission
   * to view the given group.
   * @param int frm_id
   * @return boolean permission
   ***/
  function checkGrpRights($frm_id) {
    global $conn;
    return true;
  }
  /************************************************
   * This function checks if the user has permission
   * to edit or delete a given thread.
   * @param int frm_id
   * @param int thread_id
   * @param int reply_id
   * @param String check_type (edit or delete)
   * @return boolean permission
   ***/
  function checkPermission($frm_id, $thread_id, $reply_id, $check_type){
    global $conn;
    if($this->forumSettings->allow_userEditOwnThread > 0) {
      $check_type == "edit" ? $minUserLevel = 3 : $minUserLevel = 9;
    }
    else {
      $check_type == "edit" ? $minUserLevel = 6 : $minUserLevel = 9;
    }
    $sql = "SELECT thread_rightslevel,author_id FROM ". $this->forumSettings->sql_thread_table ." 
						WHERE frm_id='". (int)$frm_id ."' 
						AND thread_id='". (int)$thread_id ."' 
						AND reply_id='". (int)$reply_id ."'
					";
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    if($row = $res->FetchRow()){
      if($this->forumUser->userLevel > $row["thread_rightslevel"]) { // FIXME userLevel
	return true;
      }
      else {
	if($this->forumUser->userLevel >= $minUserLevel && $row["author_id"] == $this->forumUser->userId) {
	  return true;
	} 
	else {
	  return false;
	}
      }
    }
  }
	
  /***********************************
   * Notify user if someone has replied
   * to his/her message (if checked!)
   * @param String email
   * @param  String Author
   * @param String Replier
   ***/
  function sendmail($email, $name, $writer, $frm_id, $thread_id) {
    global $appconf;
		

    $mail = new CMail($this->forumSettings->mail_sendFromEmail, $this->forumSettings->mail_sendfromName, $this->forumSettings->mail_displayEmail, $this->forumSettings->mail_displayUrl, $this->forumSettings->mail_header);
    $mail->writeln($name ."!");
    $mail->writeln("");
    $mail->writeln($writer ." ". $this->langText["mail1"]);
    $mail->writeln("");
    $mail->writeln($this->langText["mail2"]);
    $mail->writeln("");
    $mail->writeln(ROOTURL ."modules/forum/index.php?action=show_thread&frm_id=". $frm_id ."&thread_id=". $thread_id);
    $mail->writeln("");
    $mail->send($email, $writer ." ". $this->langText["mail1"]);
  }

  function initUser() {
    global $forumUser;
    if($this->forumSettings->with_logo > 0) $this->smarty->assign("thread_logo", $forumUser->logo);
    if($this->forumSettings->with_signature > 0) $this->smarty->assign("thread_signature", $forumUser->signature);
	
  }

  /*****************************
   * Unset Objects after use.
   ***/
  function unsetObjects() {
    unset($this->forumThreads);
    unset($this->forumGroups);
    unset($this->forumPages);
  }


  /*****************************
   * Format the text appropriately.
   ***/
  function formatText($text, $textType) {
    $tempText = htmlspecialchars($text);

    switch($textType) {
    case "title" :
      $newText = wordwrap($tempText, 20, "\n", 1);
      break;
    case "text" :
      $newText = wordwrap($tempText, 100, "\n", 1);
      break;
    }
    return $newText;
  }

}
?>